package org.codecop.basic
/**
 * Functions work on expressions and return new expressions.
 * Expressions itself are evaluated lazy during runtime because the commands
 * using them are evaluated lazily.
 * @author Peter Kofler
 */
trait BasicFunctions {

   def INT(d:DoubleExpression) = 
      new DoubleExpression {
         override def value = d.value.floor
      }
   def RND(d:DoubleExpression) = 
      new DoubleExpression {
         override def value = Math.random
      }
   def CHR$(d:DoubleExpression) = 
      new StringExpression {
         override def value = d.value.toChar.toString
      }
   def ASC(s:StringExpression) = 
      new DoubleExpression {
         override def value = s.value(0).toInt
      }

   // TODO add more like MID$, etc.

}
