package org.codecop.basic

/**
 * Interface to put BASIC code into memory and to interface with runtime from
 * the parsed tokens.
 * @author Peter Kofler
 */
trait LinesOfCode {
  
   // code adding
   def addLine(line:Int)(code: =>Unit)
   def addLoop(name:String)(incCheck: =>Boolean)
   
   // runtime operations
   def next(name:String)
   def jumpTo(line:Int)
   def end()
   
   // memory operations
   def set(name:String, value:Double)
   def get(name:String):Double
   def setString(name:String, value:String)
   def getString(name:String):String

}
