package org.codecop.basic

// ---------- parsed expressions ----------

abstract class StringExpression {
   def value:String
   def fromVariable:String = null
}
class LiteralStringExpression(val value:String) extends StringExpression

abstract class JumpTarget {
   def line:Int
}
class LiteralJumpTarget(val line:Int) extends JumpTarget

abstract class DoubleExpression {
   def value:Double
   def fromVariable:String = null
   // calculations 
   def +(d:DoubleExpression) = 
      new DoubleExpression {
         override def value = DoubleExpression.this.value + d.value
      }
   def *(d:DoubleExpression) = 
      new DoubleExpression {
         override def value = DoubleExpression.this.value * d.value
      }
   
   // comparisons
   def <(d:DoubleExpression) = value < d.value
   def <>(d:DoubleExpression) = value != d.value
}
class LiteralDoubleExpression(val value:Double) extends DoubleExpression
